import java.awt.*;

public class PolyFlip {
    public Color[] C;
    public Complex c;
    public double r1,r2;
    public int mode;
    public int hide;
    public int angle;
    public int k,n;


    public PolyFlip(double r1,double r2,int k,int n,Complex c,int hide,int mode,int angle,Color[] C) {
	this.k=k;
	this.n=n;
	this.r1=r1;
	this.r2=r2;
	this.c=c;
	this.mode=mode;
	this.hide=hide;
	this.angle=angle;
	this.C=C;
	hide=0;
    }


    public void render(Graphics g,Color C) {
	double x1,x2,x3,y1,y2,y3,x4,y4,x5,y5;
	int i,m;
	double ii,nn;
	Polygon P=new Polygon();


	for(i=0;i<this.n;++i) {
	    m=1;
	    if(this.mode==1) m=-1;
	    ii=m*i*this.k;
	    nn=this.n;
	    x1=this.c.x;
	    y1=this.c.y;
	    x2=x1+this.r2*Math.cos(2.0*Math.PI*(this.angle+ii-.5)/nn-Math.PI*this.mode); 
            y2=y1-this.r2*Math.sin(2.0*Math.PI*(this.angle+ii-.5)/nn-Math.PI*this.mode);
	    x3=x1+this.r2*Math.cos(2.0*Math.PI*(this.angle+ii+.5)/nn-Math.PI*this.mode); 
            y3=y1-this.r2*Math.sin(2.0*Math.PI*(this.angle+ii+.5)/nn-Math.PI*this.mode); 
	    x4=x1+this.r1*Math.cos(2.0*Math.PI*(this.angle+ii-.5)/nn-Math.PI*this.mode); 
            y4=y1-this.r1*Math.sin(2.0*Math.PI*(this.angle+ii-.5)/nn-Math.PI*this.mode);
	    x5=x1+this.r1*Math.cos(2.0*Math.PI*(this.angle+ii+.5)/nn-Math.PI*this.mode); 
            y5=y1-this.r1*Math.sin(2.0*Math.PI*(this.angle+ii+.5)/nn-Math.PI*this.mode); 
	    int x[]={(int)(x2),(int)(x3),(int)(x5),(int)(x4)};
            int y[]={(int)(y2),(int)(y3),(int)(y5),(int)(y4)};
	    P.xpoints=x;
	    P.ypoints=y;
	    P.npoints=4;
	    g.setColor(this.C[i]);
	    if(hide==0) g.fillPolygon(P);
	    if(hide==0) g.drawPolygon(P);
	}
    }



    public int inside(Point p) {
	double x1,x2,x3,y1,y2,y3;
	int i,m;
	double ii,nn;
	int listen;
	ListenTriangle LP;
	Polygon P=new Polygon();
	listen=-1;
	for(i=0;i<this.n;++i) {
	    m=1;
	    if(this.mode==1) m=-1;
	    ii=m*i*this.k;
	    nn=this.n;
	    x1=this.c.x;
	    y1=this.c.y;
	    x2=x1+this.r2*Math.cos(2.0*Math.PI*(this.angle+ii-.5)/nn-Math.PI*this.mode); 
            y2=y1-this.r2*Math.sin(2.0*Math.PI*(this.angle+ii-.5)/nn-Math.PI*this.mode);
	    x3=x1+this.r2*Math.cos(2.0*Math.PI*(this.angle+ii+.5)/nn-Math.PI*this.mode); 
            y3=y1-this.r2*Math.sin(2.0*Math.PI*(this.angle+ii+.5)/nn-Math.PI*this.mode); 
	    int x[]={(int)(x1),(int)(x2),(int)(x3)};
            int y[]={(int)(y1),(int)(y2),(int)(y3)};
	    P.xpoints=x;
	    P.ypoints=y;
	    P.npoints=3;
	    LP=new ListenTriangle(P);
	    if((LP.inside(p)==1)&&(this.hide==0)) listen=i;
	}


	for(i=0;i<this.n;++i) {
	    m=1;
	    if(this.mode==1) m=-1;
	    ii=m*i*this.k;
	    nn=this.n;
	    x1=this.c.x;
	    y1=this.c.y;
	    x2=x1+this.r1*Math.cos(2.0*Math.PI*(this.angle+ii-.5)/nn-Math.PI*this.mode); 
            y2=y1-this.r1*Math.sin(2.0*Math.PI*(this.angle+ii-.5)/nn-Math.PI*this.mode);
	    x3=x1+this.r1*Math.cos(2.0*Math.PI*(this.angle+ii+.5)/nn-Math.PI*this.mode); 
            y3=y1-this.r1*Math.sin(2.0*Math.PI*(this.angle+ii+.5)/nn-Math.PI*this.mode); 
	    int x[]={(int)(x1),(int)(x2),(int)(x3)};
            int y[]={(int)(y1),(int)(y2),(int)(y3)};
	    P.xpoints=x;
	    P.ypoints=y;
	    P.npoints=3;
	    LP=new ListenTriangle(P);
	    if(LP.inside(p)==1) listen=-1;
	}
	return(listen);

    }



    public PolyFlip flip(int i) {
	double x,y;
	int m;
	double len;
	double ii,nn;
	PolyFlip Q=this;
	nn=0;
	if(i>-1) {
	  if(this.mode==0) {
	    ii=i*this.k;
	    nn=this.n;
	    x=this.r2*Math.cos(2.0*Math.PI*(this.angle+ii)/nn); 
            y=this.r2*Math.sin(2.0*Math.PI*(this.angle+ii)/nn);  
            len=2*Math.cos(Math.PI/nn);
	    Q.c.x=Q.c.x+len*x;
	    Q.c.y=Q.c.y-len*y;
	    Q.angle=this.angle+2*this.k*i;
	  }

	  if(this.mode==1) {
	    ii=-i*this.k;
	    nn=this.n;
	    x=this.r2*Math.cos(2.0*Math.PI*(this.angle+ii)/nn); 
            y=this.r2*Math.sin(2.0*Math.PI*(this.angle+ii)/nn);  
            len=2*Math.cos(Math.PI/nn);
	    Q.c.x=Q.c.x-len*x;
	    Q.c.y=Q.c.y+len*y;
	    Q.angle=-2*this.k*i+this.angle;
	  }
	  Q.mode=1-this.mode;
	}
	return(Q);
    }



}
